Option Explicit
Const ForReading = 1
Const ForWriting = 2
Const ForAppending = 8

Sub forceCScriptExecution
    Dim Arg, Str
    If Not LCase( Right( WScript.FullName, 12 ) ) = "\cscript.exe" Then
        For Each Arg In WScript.Arguments
            If InStr( Arg, " " ) Then Arg = """" & Arg & """"
            Str = Str & " " & Arg
        Next
        CreateObject( "WScript.Shell" ).Run _
            "cscript //nologo """ & _
            WScript.ScriptFullName & _
            """ " & Str
        WScript.Quit
    End If
End Sub
forceCScriptExecution

Dim sLog, sBlock, sAudit, sScriptFolder
Dim oFSO, oLogFile, oBlockFile, oAuditFile
Dim sAlreadyBlocked, sLine
Dim objRegEx, colMatches 
Dim i, x

Set objRegEx = CreateObject("VBScript.RegExp")
objRegEx.Global = True   
objRegEx.Pattern = "\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}"

'NOTE: Relative directory to this script and c:\wgserv will also be checked if these paths are not defined
sAudit = "PATH TO wgsaudit.adt"
sBlock = "PATH TO blocklist.txt"

Set oFSO = CreateObject("Scripting.FileSystemObject")

Sub Close()
	On Error Resume Next
	oLogFile.close
	oBlockFile.close
	oAuditFile.close
	set oLogFile = nothing
	set oBlockFile = nothing
	set oAuditFile = nothing
	set oFSO = nothing
	wscript.quit
End Sub

Sub ErrorExit(msg)
	Log("ERROR: " & msg)
	Close()
End Sub

Sub Log(msg)
	wscript.echo msg
	oLogFile.WriteLine trim(Now & ": " & msg)
End Sub

sScriptFolder = Wscript.ScriptFullName
sScriptFolder = oFSO.GetParentFolderName(oFSO.GetFile(sScriptFolder))

if oFSO.FolderExists(sScriptFolder) = false then call ErrorExit("Error getting script folder")

sLog = sScriptFolder & "\" & wscript.ScriptName & ".log"
set oLogFile = oFSO.OpenTextFile(sLog, ForAppending, True)

if len(trim(sAudit)) > 0 AND oFSO.FileExists(sAudit) = false then
	if oFSO.FileExists(sScriptFolder & "\wgsaudit.adt") then
		sAudit = sScriptFolder & "\wgsaudit.adt"
	else
		if oFSO.FileExists("c:\wgserv\wgsaudit.adt") then
			sAudit = "c:\wgserv\wgsaudit.adt"
		else
			ErrorExit("Error finding wgsaudit.adt")
		end if
	end if
end if

if len(trim(sBlock)) > 0 AND oFSO.FileExists(sBlock) = false then
	if oFSO.FileExists(sScriptFolder & "\blocklist.txt") then
		sBlock = sScriptFolder & "\blocklist.txt"
	else
		if oFSO.FileExists("c:\wgserv\blocklist.txt") then
			sBlock = "c:\wgserv\blocklist.txt"
		else
			ErrorExit("Error finding blocklist.txt")
		end if
	end if
end if

Set oBlockFile = oFSO.OpenTextFile(sBlock, ForReading)

i = 1
WScript.Echo "Reading block file..."
Do Until oBlockFile.AtEndOfStream
	'WScript.Echo "line " & i & " ..."
	sAlreadyBlocked = sAlreadyBlocked & "#" & trim(oBlockFile.ReadLine) & "#"
	i = i + 1
Loop
oBlockFile.Close

WScript.Echo ""

Set oAuditFile = oFSO.OpenTextFile(sAudit, ForReading)
i = 1
WScript.Echo "Reading audit file..."
Do Until oAuditFile.AtEndOfStream
	'WScript.Echo "line " & i & " ..."
	sLine = trim(oAuditFile.ReadLine)
	if instr(1, sLine, "NON-SGA CLIENT", vbTextCompare) > 0 then
		Set colMatches = objRegEx.Execute(sLine)
		If colMatches.Count > 0 Then
			if instr(1, sAlreadyBlocked, "#" & colMatches(0).Value & "#", vbTextCompare) = 0 then
				
				Set oBlockFile = oFSO.OpenTextFile(sBlock, ForAppending)
				oBlockFile.WriteLine(colMatches(0).Value)
				oBlockFile.close
				Set oBlockFile = Nothing
				
				sAlreadyBlocked = sAlreadyBlocked & "#" & colMatches(0).Value & "#"
				Log(colMatches(0).Value & " added to block list.")
				
			end if
		end if
	end if
	i = i + 1
Loop
oAuditFile.Close

Close()